/*
 * File   :     jh.java
 * Author :     Tis Veugen
 * Date   :     2003-10-11
 * Version:     1.0
 */

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class jh extends Frame
   implements ActionListener, TextListener
{
  private Button                mInput;
  private Button                mOutput;
  private Button                mJoin;

  private TextField             mInputTextField;
  private TextField             mOutputTextField;
  private TextField             mNrLinesTextField;

  private BufferedReader        mInputFile = null;
  private PrintWriter           mOutputFile = null;

  private String                mDirectory = "";
  private String                msPattern;
  private Vector                mFileNames;

  private int                   mNrLines = 0;
  private int                   mIxLines = 0;
  private String                msHeader;
  private int                   mIxPage = 0;

  public                        jh()
  {
    mInputFile  = null;
    mOutputFile = null;

    setTitle( "JoinHtml (v1.0)" );

    GridBagLayout               lGbl = new GridBagLayout();
    setLayout( lGbl );

    mInput   = addButton( "Input" );
    mOutput  = addButton( "Output" );
    mJoin = addButton( "Join" );

    mInputTextField  = addTextField( 40 );
    mOutputTextField = addTextField( 40 );
    mNrLinesTextField = addTextField( 3 );
    mNrLinesTextField.setText( "" + mNrLines );

    GridBagConstraints          lGbc = new GridBagConstraints();

    lGbc.anchor = GridBagConstraints.CENTER;
    lGbc.fill   = GridBagConstraints.HORIZONTAL;
    lGbc.weightx = 20;
    lGbc.weighty = 10;

    add( mInput,   lGbc, 0, 0, 1, 1 );
    add( mOutput,  lGbc, 0, 1, 1, 1 );
    add( new Label( " NrLines ", Label.CENTER ),  lGbc, 2, 2, 1, 1 );
    add( mJoin, lGbc, 1, 2, 1, 1 );

    lGbc.fill = GridBagConstraints.NONE;
    add( mInputTextField,   lGbc, 1, 0, 3, 1 );
    add( mOutputTextField,  lGbc, 1, 1, 3, 1 );
    add( mNrLinesTextField, lGbc, 3, 2, 1, 1 );

    addWindowListener( new WindowAdapter()
                       {
                         public void windowClosing(
                         WindowEvent evt )
                         {
                           setVisible( false );
                           System.exit( 0 );
                         }
                       }
                     );

    setLocation( 100, 100 );
    setSize( 400, 100 );
}

  public void                   add(
  Component                     oComponent,
  GridBagConstraints            oGbc,
  int                           x,
  int                           y,
  int                           w,
  int                           h )
  {
    oGbc.gridx = x;
    oGbc.gridy = y;
    oGbc.gridwidth  = w;
    oGbc.gridheight = h;
    add( oComponent, oGbc );
  }

  public Button                 addButton(
  String                        oName )
  {
    Button                      lButton = new Button( oName );

    lButton.addActionListener( this );

    return lButton;
  }

  public TextField              addTextField(
  int                           size )
  {
    TextField                   lTextField = new TextField( "", size );

    lTextField.addTextListener( this );

    return lTextField;
  }

  public void                   ActionInput()
  {
    String                      lFilename;
    String                      lExtension;

    lFilename = SetFile( "*.*", "Input file", FileDialog.LOAD );
    if ( lFilename != null )
    {
      mInputTextField.setText( lFilename );
      mOutputTextField.setText( lFilename );
    }
  }

  private void                  CloseInputFile()
  {
    if ( mInputFile != null )
    {
      try
      {
        mInputFile.close();
      }
      catch ( Exception e )
      {
        System.err.println( "Can't close Input file" );
      }
      mInputFile  = null;
    }
  }

  private void                  CloseOutputFile()
  {
    if ( mOutputFile != null )
    {
      try
      {
        mOutputFile.close();
      }
      catch ( Exception e )
      {
        System.err.println( "Can't close Output file" );
      }
      mOutputFile = null;
    }
  }

  private String                OpenInputFile(
  File                          oInputFile )
  {
    try
    {
      mInputFile = new BufferedReader(
                   new FileReader( oInputFile ) );
    }
    catch ( Exception e )
    {
      return "Can't open Input file " + oInputFile.toString();
    }
    return null;
  }

  private String                OpenOutputFile(
  String                        oOutputFilename )
  {
    if ( ( oOutputFilename == null      )
      || ( oOutputFilename.equals( "" ) ) )
    {
      return " No Output file";
    }

    try
    {
      mOutputFile = new PrintWriter(
                    new FileWriter( oOutputFilename, false ) );
    }
    catch ( Exception e )
    {
      return "Can't open Output file " + oOutputFilename;
    }

    return null;
  }

  private String                SetFile(
  String                        oFilter,
  String                        oHeader,
  int                           iMode )
  {
    FileDialog                  lFd;
    String                      lFilename;

    lFd = new FileDialog( this      // mFrame
                        , oHeader
                        , iMode );
    lFd.setDirectory( mDirectory );
    lFd.setFile( oFilter );
    lFd.show();

    lFilename = lFd.getFile();
    if ( lFilename != null )
    {
      mDirectory = lFd.getDirectory();
      lFilename = mDirectory + lFilename;
    }

    return lFilename;
  }

  private void                  PrintDialog(
  boolean                       bDialog,
  Frame                         oFrame,
  String                        oHeader,
  String                        oText )
  {
    if ( bDialog )
    {
      new PbnDialog( oFrame, oHeader, oText );
    }
    else
    {
      System.out.println( oText );
    }
  }

  private boolean               MyRename(
  String                        oSourceFilename,
  String                        oTargetFilename )
  {
    File                        lSourceFile = new File( oSourceFilename );
    File                        lTargetFile = new File( oTargetFilename );

    try
    {
      lTargetFile.delete();
      lSourceFile.renameTo( lTargetFile );
    }
    catch ( Exception e )
    {
      return false;
    }
    return true;
  }

  private boolean               ActionJoin(
  String                        oInputFilename,
  String                        oOutputFilename,
  boolean                       bDialog )
  {
    String                      lString;
    boolean                     bOK = true;

    File                        lFile = new File( oInputFilename );
    msPattern = lFile.getName();

    lString = OpenOutputFile( oOutputFilename );
    if ( lString != null )
    {
      PrintDialog( bDialog, this, "Files", lString );
    }
    else
    {
      if ( bDialog )
      {
        this.setCursor( new Cursor( Cursor.WAIT_CURSOR ) );
      }

      mFileNames = new Vector();
      JoinDir( lFile.getParent(), bDialog );
/*
      msHeader = "Overview";
      mIxPage = 0;
      mIxLines = 0;
      for ( int i = 0; i < mFileNames.size(); i++ )
      {
        WriteOut( (String) mFileNames.elementAt( i ) );
      }
*/
      if ( bDialog )
      {
        this.setCursor( new Cursor( Cursor.DEFAULT_CURSOR ) );
      }
    }

    CloseInputFile();
    CloseOutputFile();
    return bOK;
  }

  private void                  JoinDir(
  String                        oDirname,
  boolean                       bDialog )
  {
    File                        lDirectory;
    String []                   lFiles;

    try
    {
      lDirectory = new File( oDirname );
      lFiles = lDirectory.list();
      if ( lFiles == null )
      { /*
         * No files in this dir.
         */
        return;
      }
    }
    catch ( Exception e )
    {
      System.err.println( "Can't construct directory" );
      return;
    }

    for ( int i = 0; i < lFiles.length; i++ )
    {
      File lFile = new File( oDirname, lFiles[ i ] );
      if ( lFile.isFile() )
      {
        if ( PatternMatch.Match( lFile.getName(), msPattern ) )
        {
          JoinFile( lFile, bDialog );
        }
      }
    }

    for ( int i = 0; i < lFiles.length; i++ )
    {
      File lFile = new File( oDirname, lFiles[ i ] );
      if ( ! lFile.isFile() )
      {
        JoinDir( lFile.getPath(), bDialog );
      }
    }
  }

  private void                  JoinFile(
  File                          lFile,
  boolean                       bDialog )
  {
    String                      lInput;
    boolean                     bOk = true;

    try
    {
      String                    sName = lFile.toString();

      mFileNames.addElement( sName );
      msHeader = sName;
      mIxPage = 0;
      mIxLines = 0;

      String result = OpenInputFile( lFile );
      if ( result != null )
      {
        WriteOut( result );
      }
      else
      {
        while ( (lInput = mInputFile.readLine()) != null )
        {
          WriteOut( lInput );
        }

        CloseInputFile();
      }
/*
      if ( ( mNrLines == 0 )
        || ( mIxLines != 0 ) )
      {
        mIxLines = 0;
        mOutputFile.write( "\u000C" );
      }
*/
    }
    catch ( Exception e )
    {
      bOk = false;
    }

    if ( ! bOk )
    {
      try
      {
        WriteOut( "-problem-" );
      }
      catch ( Exception e )
      {
        bOk = false;
      }
    }
  }

  private void                  WriteOut(
  String                        s )
  {
    try
    {
      if ( mIxLines == 0 )
      {
        mIxPage++;
/*
        mOutputFile.write( msHeader + "  p. " + mIxPage + "\n" );
        mOutputFile.write( "------------------------------------------------------" + "\n" );
        mIxLines = 2;
*/
        mOutputFile.write( "<html>" );
        mOutputFile.write( "<body>" );
        mOutputFile.write( "<!--NewPage-->" );
        mOutputFile.write( "<h2>" + "------------------------------------------------------" + " </h2>" + "\n" );
//        mOutputFile.write( "<br>" );
        mOutputFile.write( "<h2>" + msHeader + " </h2>" + "\n" );
//        mOutputFile.write( "<br>" );
        mOutputFile.write( "<h2>" + "------------------------------------------------------" + " </h2>" + "\n" );
//        mOutputFile.write( "<br>" );
        mOutputFile.write( "</body>" );
        mOutputFile.write( "</html>" );
        mIxLines = 3;
      }

      mOutputFile.write( s + "\n" );
      mIxLines++;
/*
      if ( ( mNrLines > 0 )
        && ( mIxLines >= mNrLines ) )
      {
        mIxLines = 0;
        mOutputFile.write( "\u000C" );
      }
*/
     }
    catch ( Exception e )
    {
    }
  }

  private void                  DoAction()
  {
    String s = mNrLinesTextField.getText();
    mNrLines = Integer.parseInt( s );
    if ( mNrLines < 3 ) mNrLines = 0;

    ActionJoin( mInputTextField.getText()
              , mOutputTextField.getText()
              , true );
    PrintDialog( true, this, "Print Result", "Ready" );
  }

  public void                   actionPerformed(
  ActionEvent                   evt )
  {
    String                      lName = evt.getActionCommand();
    String                      lFilename;

    if ( lName.equals( "Input" ) )
    {
      ActionInput();
    }
    else
    if ( lName.equals( "Output" ) )
    {
      lFilename = SetFile( "*.*", "Output file", FileDialog.LOAD );
      if ( lFilename != null )
      {
        mOutputTextField.setText( lFilename );
      }
    }
    else
    if ( lName.equals( "Join" ) )
    {
      DoAction();
    }
  }

  public void                   textValueChanged(
  TextEvent                     evt )
  {
  }

  public static void            main(
  String []                     args )
  {
    Frame                       lJoin;

    lJoin = new jh();
    lJoin.show();
  }
}

class PbnDialog extends Dialog
{
  public                        PbnDialog(
  Frame                         oParent,
  String                        oHeader,
  String                        oText )
  {
    super( oParent, oHeader, true );

    Panel                       lPanel = new Panel();
    int                         NrLines;
    int                         Index;

    for ( NrLines = 0; ; NrLines++ )
    {
      Index = oText.indexOf( "\n" );
      if ( Index < 0 )
      {
        lPanel.add( new Label( oText ) );
        break;
      }
      lPanel.add( new Label( oText.substring( 0, Index ) ) );
      oText = oText.substring( Index+1 );
    }
    add( lPanel, "Center" );

    Button                      mOk = new Button( "OK" );
    lPanel = new Panel();
    lPanel.add( mOk );
    add( lPanel, "South" );

    mOk.addActionListener( new ActionListener()
                           {
                             public void actionPerformed(
                             ActionEvent evt )
                             {
                               setVisible( false );
                             }
                           }
                         );

        addWindowListener( new WindowAdapter()
                           {
                             public void windowClosing(
                             WindowEvent evt )
                             {
                               setVisible( false );
                             }
                           }
                         );

    setLocation( 150, 150 );
    setSize( 300, 120 + NrLines * 30 );
    show();
  }
}